QCPLegend Class Reference

Manages a legend inside a QCustomPlot. More...

Inheritance diagram for QCPLegend:

## Public Types

enum | SelectablePart { spNone = 0x000, spLegendBox = 0x001, spItems = 0x002 }

## Signals

void | selectionChanged (QCPLegend::SelectableParts selection)

## Public Member Functions

| QCPLegend ()
QPen | borderPen () const
QBrush | brush () const
QFont | font () const
QColor | textColor () const
QSize | iconSize () const
int | iconTextPadding () const
QPen | iconBorderPen () const
SelectableParts | selectableParts () const
SelectableParts | selectedParts () const
QPen | selectedBorderPen () const
QPen | selectedIconBorderPen () const
QBrush | selectedBrush () const
QFont | selectedFont () const
QColor | selectedTextColor () const
void | setBorderPen (const QPen &pen)
void | setBrush (const QBrush &brush)
void | setFont (const QFont &font)
void | setTextColor (const QColor &color)
void | setIconSize (const QSize &size)
void | setIconSize (int width, int height)
void | setIconTextPadding (int padding)
void | setIconBorderPen (const QPen &pen)
void | setSelectableParts (const SelectableParts &selectableParts)
void | setSelectedParts (const SelectableParts &selectedParts)
void | setSelectedBorderPen (const QPen &pen)
void | setSelectedIconBorderPen (const QPen &pen)
void | setSelectedBrush (const QBrush &brush)
void | setSelectedFont (const QFont &font)
void | setSelectedTextColor (const QColor &color)
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=0) const
QCPAbstractLegendItem * | item (int index) const
QCPPlottableLegendItem * | itemWithPlottable (const QCPAbstractPlottable *plottable) const
int | itemCount () const
bool | hasItem (QCPAbstractLegendItem *item) const
bool | hasItemWithPlottable (const QCPAbstractPlottable *plottable) const
bool | addItem (QCPAbstractLegendItem *item)
bool | removeItem (int index)
bool | removeItem (QCPAbstractLegendItem *item)
void | clearItems ()
QList< QCPAbstractLegendItem * > | selectedItems () const
Public Member Functions inherited from QCPLayoutGrid
| QCPLayoutGrid ()
int | rowCount () const
int | columnCount () const
QList< double > | columnStretchFactors () const
QList< double > | rowStretchFactors () const
int | columnSpacing () const
int | rowSpacing () const
void | setColumnStretchFactor (int column, double factor)
void | setColumnStretchFactors (const QList< double > &factors)
void | setRowStretchFactor (int row, double factor)
void | setRowStretchFactors (const QList< double > &factors)
void | setColumnSpacing (int pixels)
void | setRowSpacing (int pixels)
virtual void | updateLayout ()
virtual int | elementCount () const
virtual QCPLayoutElement * | elementAt (int index) const
virtual QCPLayoutElement * | takeAt (int index)
virtual bool | take (QCPLayoutElement *element)
virtual QList< QCPLayoutElement * > | elements (bool recursive) const
virtual void | simplify ()
virtual QSize | minimumSizeHint () const
virtual QSize | maximumSizeHint () const
QCPLayoutElement * | element (int row, int column) const
bool | addElement (int row, int column, QCPLayoutElement *element)
bool | hasElement (int row, int column)
void | expandTo (int newRowCount, int newColumnCount)
void | insertRow (int newIndex)
void | insertColumn (int newIndex)
Public Member Functions inherited from QCPLayout
| QCPLayout ()
virtual void | update ()
bool | removeAt (int index)
bool | remove (QCPLayoutElement *element)
void | clear ()
Public Member Functions inherited from QCPLayoutElement
| QCPLayoutElement (QCustomPlot *parentPlot=0)
QCPLayout * | layout () const
QRect | rect () const
QRect | outerRect () const
QMargins | margins () const
QMargins | minimumMargins () const
QCP::MarginSides | autoMargins () const
QSize | minimumSize () const
QSize | maximumSize () const
QCPMarginGroup * | marginGroup (QCP::MarginSide side) const
QHash< QCP::MarginSide, QCPMarginGroup * > | marginGroups () const
void | setOuterRect (const QRect &rect)
void | setMargins (const QMargins &margins)
void | setMinimumMargins (const QMargins &margins)
void | setAutoMargins (QCP::MarginSides sides)
void | setMinimumSize (const QSize &size)
void | setMinimumSize (int width, int height)
void | setMaximumSize (const QSize &size)
void | setMaximumSize (int width, int height)
void | setMarginGroup (QCP::MarginSides sides, QCPMarginGroup *group)
Public Member Functions inherited from QCPLayerable
| QCPLayerable (QCustomPlot *plot, QString targetLayer="", QCPLayerable *parentLayerable=0)
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
bool | realVisibility () const

## Protected Member Functions

virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
virtual QCP::Interaction | selectionCategory () const
virtual void | applyDefaultAntialiasingHint (QCPPainter *painter) const
virtual void | draw (QCPPainter *painter)
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
QPen | getBorderPen () const
QBrush | getBrush () const
Protected Member Functions inherited from QCPLayoutGrid
void | getMinimumRowColSizes (QVector< int > *minColWidths, QVector< int > *minRowHeights) const
void | getMaximumRowColSizes (QVector< int > *maxColWidths, QVector< int > *maxRowHeights) const
Protected Member Functions inherited from QCPLayout
void | sizeConstraintsChanged () const
void | adoptElement (QCPLayoutElement *el)
void | releaseElement (QCPLayoutElement *el)
QVector< int > | getSectionSizes (QVector< int > maxSizes, QVector< int > minSizes, QVector< double > stretchFactors, int totalSize) const
Protected Member Functions inherited from QCPLayoutElement
virtual int | calculateAutoMargin (QCP::MarginSide side)
virtual void | mousePressEvent (QMouseEvent *event)
virtual void | mouseMoveEvent (QMouseEvent *event)
virtual void | mouseReleaseEvent (QMouseEvent *event)
virtual void | mouseDoubleClickEvent (QMouseEvent *event)
virtual void | wheelEvent (QWheelEvent *event)
Protected Member Functions inherited from QCPLayerable
virtual QRect | clipRect () const
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Protected Attributes

QPen | mBorderPen
QPen | mIconBorderPen
QBrush | mBrush
QFont | mFont
QColor | mTextColor
QSize | mIconSize
int | mIconTextPadding
SelectableParts | mSelectedParts
SelectableParts | mSelectableParts
QPen | mSelectedBorderPen
QPen | mSelectedIconBorderPen
QBrush | mSelectedBrush
QFont | mSelectedFont
QColor | mSelectedTextColor
Protected Attributes inherited from QCPLayoutGrid
QList< QList< QCPLayoutElement * > > | mElements
QList< double > | mColumnStretchFactors
QList< double > | mRowStretchFactors
int | mColumnSpacing
int | mRowSpacing
Protected Attributes inherited from QCPLayoutElement
QCPLayout * | mParentLayout
QSize | mMinimumSize
QSize | mMaximumSize
QRect | mRect
QRect | mOuterRect
QMargins | mMargins
QMargins | mMinimumMargins
QCP::MarginSides | mAutoMargins
QHash< QCP::MarginSide, QCPMarginGroup * > | mMarginGroups
Protected Attributes inherited from QCPLayerable
bool | mVisible
QCustomPlot * | mParentPlot
QPointer< QCPLayerable > | mParentLayerable
QCPLayer * | mLayer
bool | mAntialiased

## Friends

class | QCustomPlot
class | QCPAbstractLegendItem

## Detailed Description

Manages a legend inside a QCustomPlot.

A legend is a small box somewhere in the plot which lists plottables with their name and icon.

Normally, the legend is populated by calling QCPAbstractPlottable::addToLegend. The respective legend item can be removed with QCPAbstractPlottable::removeFromLegend. However, QCPLegend also offers an interface to add and manipulate legend items directly: item, itemWithPlottable, itemCount, addItem, removeItem, etc.

The QCPLegend derives from QCPLayoutGrid and as such can be placed in any position a QCPLayoutElement may be positioned. The legend items are themselves QCPLayoutElements which are placed in the grid layout of the legend. QCPLegend only adds an interface specialized for handling child elements of type QCPAbstractLegendItem, as mentioned above. In principle, any other layout elements may also be added to a legend via the normal QCPLayoutGrid interface. However, the QCPAbstractLegendItem-Interface will ignore those elements (e.g. itemCount will only return the number of items with QCPAbstractLegendItems type).

By default, every QCustomPlot has one legend (QCustomPlot::legend) which is placed in the inset layout of the main axis rect (QCPAxisRect::insetLayout). To move the legend to another position inside the axis rect, use the methods of the QCPLayoutInset. To move the legend outside of the axis rect, place it anywhere else with the QCPLayout/QCPLayoutElement interface.

## Member Enumeration Documentation

enum QCPLegend::SelectablePart

Defines the selectable parts of a legend

See also
  setSelectedParts, setSelectableParts

Enumerator
spNone | `0x000` None
spLegendBox | `0x001` The legend box (frame)
spItems | `0x002` Legend items individually (see selectedItems)

## Constructor & Destructor Documentation

QCPLegend::QCPLegend | ( |  | ) |

explicit

Constructs a new QCPLegend instance with parentPlot as the containing plot and default values.

Note that by default, QCustomPlot already contains a legend ready to be used as QCustomPlot::legend

## Member Function Documentation

bool QCPLegend::addItem | ( | QCPAbstractLegendItem * | item | ) |

Adds item to the legend, if it's not present already.

Returns true on sucess, i.e. if the item wasn't in the list already and has been successfuly added.

The legend takes ownership of the item.

void QCPLegend::clearItems | ( |  | ) |

Removes all items from the legend.

bool QCPLegend::hasItem | ( | QCPAbstractLegendItem * | item | ) | const

Returns whether the legend contains itm.

bool QCPLegend::hasItemWithPlottable | ( | const QCPAbstractPlottable * | plottable | ) | const

Returns whether the legend contains a QCPPlottableLegendItem which is associated with plottable (e.g. a QCPGraph*). If such an item isn't in the legend, returns false.

See also
  itemWithPlottable

QCPAbstractLegendItem * QCPLegend::item | ( | int | index | ) | const

Returns the item with index i.

See also
  itemCount

int QCPLegend::itemCount | ( |  | ) | const

Returns the number of items currently in the legend.

See also
  item

QCPPlottableLegendItem * QCPLegend::itemWithPlottable | ( | const QCPAbstractPlottable * | plottable | ) | const

Returns the QCPPlottableLegendItem which is associated with plottable (e.g. a QCPGraph*). If such an item isn't in the legend, returns 0.

See also
  hasItemWithPlottable

bool QCPLegend::removeItem | ( | int | index | ) |

Removes the item with index index from the legend.

Returns true, if successful.

See also
  itemCount, clearItems

bool QCPLegend::removeItem | ( | QCPAbstractLegendItem * | item | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Removes item from the legend.

Returns true, if successful.

See also
  clearItems

QList< QCPAbstractLegendItem * > QCPLegend::selectedItems | ( |  | ) | const

Returns the legend items that are currently selected. If no items are selected, the list is empty.

See also
  QCPAbstractLegendItem::setSelected, setSelectable

void QCPLegend::selectionChanged | ( | QCPLegend::SelectableParts | selection | ) |

signal

This signal is emitted when the selection state of this legend has changed.

See also
  setSelectedParts, setSelectableParts

double QCPLegend::selectTest | ( | const QPointF & | pos,
|  | bool | onlySelectable,
|  | QVariant * | details = `0`
| ) |  | const

virtual

Layout elements are sensitive to events inside their outer rect. If pos is within the outer rect, this method returns a value corresponding to 0.99 times the parent plot's selection tolerance. However, layout elements are not selectable by default. So if onlySelectable is true, -1.0 is returned.

See QCPLayerable::selectTest for a general explanation of this virtual method.

QCPLayoutElement subclasses may reimplement this method to provide more specific selection test behaviour.

Reimplemented from QCPLayoutElement.

void QCPLegend::setBorderPen | ( | const QPen & | pen | ) |

Sets the pen, the border of the entire legend is drawn with.

void QCPLegend::setBrush | ( | const QBrush & | brush | ) |

Sets the brush of the legend background.

void QCPLegend::setFont | ( | const QFont & | font | ) |

Sets the default font of legend text. Legend items that draw text (e.g. the name of a graph) will use this font by default. However, a different font can be specified on a per-item-basis by accessing the specific legend item.

This function will also set font on all already existing legend items.

See also
  QCPAbstractLegendItem::setFont

void QCPLegend::setIconBorderPen | ( | const QPen & | pen | ) |

Sets the pen used to draw a border around each legend icon. Legend items that draw an icon (e.g. a visual representation of the graph) will use this pen by default.

If no border is wanted, set this to Qt::NoPen.

void QCPLegend::setIconSize | ( | const QSize & | size | ) |

Sets the size of legend icons. Legend items that draw an icon (e.g. a visual representation of the graph) will use this size by default.

void QCPLegend::setIconSize | ( | int | width,
|  | int | height
| ) |  |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

void QCPLegend::setIconTextPadding | ( | int | padding | ) |

Sets the horizontal space in pixels between the legend icon and the text next to it. Legend items that draw an icon (e.g. a visual representation of the graph) and text (e.g. the name of the graph) will use this space by default.

void QCPLegend::setSelectableParts | ( | const SelectableParts & | selectable | ) |

Sets whether the user can (de-)select the parts in selectable by clicking on the QCustomPlot surface. (When QCustomPlot::setInteractions contains iSelectLegend.)

However, even when selectable is set to a value not allowing the selection of a specific part, it is still possible to set the selection of this part manually, by calling setSelectedParts directly.

See also
  SelectablePart, setSelectedParts

void QCPLegend::setSelectedBorderPen | ( | const QPen & | pen | ) |

When the legend box is selected, this pen is used to draw the border instead of the normal pen set via setBorderPen.

See also
  setSelectedParts, setSelectableParts, setSelectedBrush

void QCPLegend::setSelectedBrush | ( | const QBrush & | brush | ) |

When the legend box is selected, this brush is used to draw the legend background instead of the normal brush set via setBrush.

See also
  setSelectedParts, setSelectableParts, setSelectedBorderPen

void QCPLegend::setSelectedFont | ( | const QFont & | font | ) |

Sets the default font that is used by legend items when they are selected.

This function will also set font on all already existing legend items.

See also
  setFont, QCPAbstractLegendItem::setSelectedFont

void QCPLegend::setSelectedIconBorderPen | ( | const QPen & | pen | ) |

Sets the pen legend items will use to draw their icon borders, when they are selected.

See also
  setSelectedParts, setSelectableParts, setSelectedFont

void QCPLegend::setSelectedParts | ( | const SelectableParts & | selected | ) |

Sets the selected state of the respective legend parts described by SelectablePart. When a part is selected, it uses a different pen/font and brush. If some legend items are selected and selected doesn't contain spItems, those items become deselected.

The entire selection mechanism is handled automatically when QCustomPlot::setInteractions contains iSelectLegend. You only need to call this function when you wish to change the selection state manually.

This function can change the selection state of a part even when setSelectableParts was set to a value that actually excludes the part.

emits the selectionChanged signal when selected is different from the previous selection state.

Note that it doesn't make sense to set the selected state spItems here when it wasn't set before, because there's no way to specify which exact items to newly select. Do this by calling QCPAbstractLegendItem::setSelected directly on the legend item you wish to select.

See also
  SelectablePart, setSelectableParts, selectTest, setSelectedBorderPen, setSelectedIconBorderPen, setSelectedBrush, setSelectedFont

void QCPLegend::setSelectedTextColor | ( | const QColor & | color | ) |

Sets the default text color that is used by legend items when they are selected.

This function will also set color on all already existing legend items.

See also
  setTextColor, QCPAbstractLegendItem::setSelectedTextColor

void QCPLegend::setTextColor | ( | const QColor & | color | ) |

Sets the default color of legend text. Legend items that draw text (e.g. the name of a graph) will use this color by default. However, a different colors can be specified on a per-item-basis by accessing the specific legend item.

This function will also set color on all already existing legend items.

See also
  QCPAbstractLegendItem::setTextColor

The documentation for this class was generated from the following files:

- qcustomplot.h
- qcustomplot.cpp